<template>
    <div>
        <h1>Index page</h1>

        <div>
            On mounted, we retrieve the following data from the server (using fetch and a generated client from an openapi spec):

            <ul>
              <li v-for="hostSetting in hostSettings" :key="hostSetting.id">
                {{ hostSetting }}
              </li>
            </ul>

          <p>
          Then we retrieve one element only :
            {{hostSettingsOne}}
          </p>

          <div>
            Another call with a post API

            <button @click="postHostSetting">Submit a host</button>

            <pre>
            {{hostSettingsSubmitted}}
            </pre>

          </div>

        </div>
      <div v-if="errorTxt" >
        {{errorTxt}}

      </div>
    </div>
  <div>
    Recap :
    <ul>
      <li>No hardcoded url in the code - OK
        <pre>
          hostSettings.value = await api.getAllHostsettings()
        </pre>
      </li>
      <li>Generated types for request and response - OK
        <pre>
          const hostSettingsOne = ref&lt;HostSettings&gt;();
          hostSettingsOne.value = await api.getApiHostsettings({ id: 1 });
        </pre>
      </li>
      <li>
        Typed error - OK
        <pre>
            catch (error: ResponseError) {
            errorTxt.value = `Error : ${error} - ${error.response.status}`;
            console.log(error);
            }
        </pre>
      </li>
      <li>
        No boiler plate, no duplicated code - OK
        <pre>
            Everything is generated from the openapi spec. Boiler plate exists but not in the code seen by the developer
        </pre>
      </li>
      <li>
        Use UniversalFetch - NOT OK right now.
        <pre>
            We have to tweak openapi generator to use UniversalFetch instead of fetch
        </pre>
      </li>
      <li>
        Documentation and playground available on the swagger UI. (same as today)
      </li>
    </ul>
  </div>

</template>

<script setup lang="ts">
import { ref } from "vue";
import {
  AddHostSettingsRequest,
  Configuration,
  HostSettings,
  HostSettingsApiApi, HostSettingsTypeEnum,
  ResponseError
} from "~/scripts/app-api-client";

const hostSettings = ref<HostSettings[]>([]);
const hostSettingsOne = ref<HostSettings>();
const hostSettingsSubmitted = ref<HostSettings>();
const errorTxt = ref("");
const configuration = new Configuration({
  basePath: 'http://localhost:8080',
});

const api = new HostSettingsApiApi(configuration);

try {
  hostSettings.value = await api.getAllHostsettings()
  hostSettingsOne.value = await api.getApiHostsettings({ id: 1 });
} catch (error) {
  console.log(error);
}

async function postHostSetting() {
  try {
    const newHostSetting: AddHostSettingsRequest =  {hostSettings : {email : "test" , id : 3 , url : "/newHost", type : HostSettingsTypeEnum.Beta, socialNetworks : []}};
    hostSettingsSubmitted.value = await api.addHostSettings(newHostSetting);
  } catch (error: ResponseError) {
    errorTxt.value = `Error : ${error} - ${error.response.status}`;
    console.log(error);
  }
}



</script>
